/*
  cPDBM.h - Emerald checkPoint database manager
 
  Copyright 1987 Clinton Jeffery
  Last edit: 11/13/87
 
  This module manages database operations.  The database is kept both
  in the standard Emerald Object Table and on disk in an NDBM(1) file.
  Database entries are exactly the object descriptors for all
  objects which have invoked a checkpoint operation.  This
  violently simplifies the reconstruction of the object table.

  Operations are:
  Load database entries from disk into the object table,
  Read the database (from the object table), and
  Write the database (write-through Object Table to disk).
  Initialize the database (open/create)
  Finalize the database
*/
#ifndef PBLKSIZ
#include "ndbm.h"
#endif

extern DBM *CP_DBM;
#ifdef CPNEWLOG
extern DBM *newCP_DBM;
#endif

extern GODP CP_LoadDbase();

extern void CP_ReadDbase(/* obj, offset, size */);
/*
  OID *obj;
  long *offset,*size;  return values
*/

extern int CP_WriteDbase(/* obj, offset, size */);
/*
  ODP *obj;
  long offset,size;
*/

extern int CP_InitDbase(); /* returns nil or succeeds... */

extern CP_FlushDbase();

extern void CP_FinalizeDbase();
