typedef struct EmTime {
    ODTag                tag;
    CodePtr              myCodePtr;
    OID                  ownOID;		/* since it is immutable */
    struct timeval       t;
} EmTime, *EmTimePtr;

typedef struct EmString {
    ODTag		 tag;
    CodePtr		 myCodePtr;
    OID			 ownOID;		/* since it is immutable */
    int			 sizeInBytes;
    Bytes                data[ /* numEntries */ 8];
} EmString, *EmStringPtr;

typedef struct EmBitChunk {
    ODTag		 tag;
    CodePtr		 myCodePtr;
    int			 lengthInBytes;
    int			 sizeInBytes;
    Bytes                data[ /* numEntries */ 8];
} EmBitChunk, *EmBitChunkPtr;

typedef struct EmInStream {
    ODTag		 tag;
    CodePtr		 myCodePtr;
    MonitorLock          lock;
    int 		 myfd;
    Boolean		 isBroken;
    int			 bufsize; /* == 1024 */
    int			 maxValidIndex;
    int			 minValidIndex;
    Boolean		 isClosed;
    VectorPtr		 buffer;
} EmInStream, *EmInStreamPtr;

typedef struct EmOutStream {
    ODTag		 tag;
    CodePtr		 myCodePtr;
    MonitorLock          lock;
    int			 myfd;
    Boolean		 isBroken;
    Boolean		 isClosed;
    int			 bufsize; /* == 1024 */
    VectorPtr		 buffer;
} EmOutStream, *EmOutStreamPtr;

typedef struct EmNode {
    ODTag		 tag;
    CodePtr		 myCodePtr;
} EmNode, *EmNodePtr;

typedef struct EmNodeListElement {
    ODTag		 tag;
    CodePtr		 myCodePtr;
    OID			 ownOID;		/* since it is immutable */
    Boolean		 up;
    int			 LNN;
    GODP		 theNode;
    EmTimePtr		 incarnationTime;
} EmNodeListElement, *EmNodeListElementPtr;

typedef struct EmNodeList {
    ODTag		 tag;
    CodePtr		 myCodePtr;
    int			 upperbound;
    int			 sizeInBytes;
    AVariable		 data[ /* upperbound + 1 */ 8 ];
} EmNodeList, *EmNodeListPtr;
