#define	FAC_Boot		((unsigned)0x0000000E)
#define	VER_Boot		((unsigned)0x00000001)
#define	ABV_Boot		"BOOT"
#define	KMSG_Boot		((unsigned)0x000E0001)

/*
 * Kernel Boot symbolic constants.
 */

/*
 * Failure codes
 */
#define	BOOTF_NoEdenUser		((unsigned)0x000E0002)
/* "No user account for '%s' on this machine." */
#define	BOOTF_CantVOIT		((unsigned)0x000E000A)
/* "Can't initialize VOIT: %08x..." */
#define	BOOTF_CantDIRT		((unsigned)0x000E0012)
/* "Can't initialize DIRT: %08x..." */
#define	BOOTF_CantExecA		((unsigned)0x000E001A)
/* "Can't exec process A." */
#define	BOOTF_ANoAnswer		((unsigned)0x000E0022)
/* "Process A didn't answer." */

/*
 * Information and state codes.
 */
#define	BOOTI_NoTempDir		((unsigned)0x000E0003)
/* "No temp directory.  Created %s." */
#define	BOOTI_ProcAMsg		((unsigned)0x000E000B)
/* "Process A says \"%s\"." */
#define	BOOTI_ProcID		((unsigned)0x000E0013)
/* "Process id %d." */
#define	BOOTI_ProcAAlive		((unsigned)0x000E001B)
/* "I'm alive." */
#define	BOOTI_TopOfMain		((unsigned)0x000E0023)
/* "Top of main loop." */
#define	BOOTI_Killed		((unsigned)0x000E002B)
/* "Killed." */

/*
 * Boot message types.
 *
 */
#define	BOOTM_Broadcast		((unsigned)0x000E0005)
/* "Kernel -> All Kernels: New node booted." */
#define	BOOTM_Reply		((unsigned)0x000E000D)
/* "Boot broadcast reply." */
#define	BOOTM_StartUp		((unsigned)0x000E0015)
/* "Node starting up." */
#define	BOOTM_ShutDown		((unsigned)0x000E001D)
/* "Node shutting down." */
#define	BOOTM_NetStatus		((unsigned)0x000E0025)
/* "Eden Network status inquiry." */
#define	BOOTM_NetStatReply		((unsigned)0x000E002D)
/* "Reply to NetWork status inquiry." */

