
/*  C O P Y R I G H T   N O T I C E :                                     */
/* Copyright 1986 Eric Jul.  May not be used for any 			  */
/* purpose without written permission from the author.			  */

/* File: /usr/Em/Kernel/h/Defs.h  Date: 1986-05-01  */

/*
 * $Header:   /u1/Eden/Source/KMDOps/RCS/Defs.v  Revision 1.6  83/06/16  06:13:54  eric  Exp$
 * INTERFACE:	None.
 *
 * FUNCTION:	Provides the KMD global type definitions.
 *
 * IMPORTS:	Nothing.
 *
 * EXPORTS:	KMDTest, KMDDataType, KMDDataPtr.
 *
 * DESIGN:	
 *
 * $Log:	/u1/Eden/Source/KMDOps/RCS/Defs.v $
Revision 1.6  83/06/16  06:13:54  eric
Test output disabled.

Revision 1.5  83/06/15  04:49:10  eric
Corrected error in preceeding correction.

Revision 1.4  83/06/15  04:43:24  eric
Error corrected in constants definition.

Revision 1.3  83/06/15  03:08:54  eric
Message Type constants inserted. Eric Jul.

Revision 1.2  83/06/12  22:01:19  eric
Syntax Errors corrected after initial implementation.

Revision 1.1  83/06/12  18:33:33  eric
Initial revision

 * 1983-06-11:	Initial implementation. Eric Jul.
 */

#ifndef KMDTESTVALUE
#define KMDTESTVALUE 0
extern int KMDTest;      /* Test Output flag for KMD. */
#define KMDMAXMESSAGESIZE 1200
typedef struct KMDDataType {
    int         MsgType;
    int         MsgInt;
    char        MsgString[KMDMAXMESSAGESIZE];
} KMDDataType, *KMDDataPtr;

typedef struct {
    int                 totalSize;
    KMDDataType         data;
} KMDMsg, *KMDMsgPtr;

/*  MsgType values are defined by the following constants.      */
#define KMDCDATA           1    /* Plain data (int, string)     */
#define KMDCTRACE          2    /* A trace start request.       */
#define KMDCUNTRACE        3    /* A stop trace request.        */
#define KMDCSNAPSHOT       4    /* A snapshot request.          */
#define KMDCPRINTVAR       5    /* A print variable request.    */
#define KMDCCHANGEVAR      6    /* A change variable request.   */
#define KMDCERRMSG         7    /* A error message request.     */
#define KMDCLASTMSG        8    /* The last message request.    */
#define KMDCBYTES          9    /* A block of bytes.            */
#define KMDCGETBYTES      10    /* Get bytes request.           */
#define KMDCPUTBYTES      11    /* Put bytes request.           */
#define KMDCTRACESTDOUT   12    /* Start trace to stdout        */
#define KMDCUNTRACESTDOUT 13    /* Stop trace to stdout         */
#define KMDREADLINE	  14    /* Read from user */
#define KMDREADLINEANS	  15    /* Line Read */
					
#define KMDSTDOUTSOCK -1

extern KKStatus KMDReceive(), KMDSend();
#endif
