/* File:   /u1/Eden/Kernel/kmdTypes.h   Date: 1984-03-28  */

/*
 * $Header$
 * INTERFACE:	None.
 *
 * FUNCTION:	Define the Kernel Measurement and Debug interface.
 *
 * IMPORTS:	Nothing.
 *
 * EXPORTS:	DebugMsg, ErrMsg
 *
 * DESIGN:	DebugMsg is defined as a macro.
 *
 * $Log$
 * 1984-03-28:	Initial implementation. Eric Jul.
 */

#ifndef kmdTypes
#define kmdTypes

extern  int anyKMD;             /* True iff any debugging or tracing at all.*/
extern  int anyKMDTrace;        /* True iff any KMDTracing. */
extern  int DebugLevel;         /* Level of DebugMsg debugging msgs. */

extern void DebugMsg1();
extern void KMDSetSnap1();
extern void KMDSetTrace1();
extern void KMDSetVar1();
extern void KMDTrace1();
extern void KMDTracex1();
extern void KMDPrepareTrace();
extern void KMDInit();
extern void KMDPrint();

#define DebugMsg if (anyKMD)    DebugMsg1

#define KMDSetSnap(theName)     KMDSetSnap1("theName", theName)
#define KMDSetTrace(theName)    KMDSetTrace1("theName")
#define KMDSetVar(theName)      KMDSetVar1("theName", &theName)
#define KMDSetProcedure(theName)KMDSetVar1("theName", theName)
#define KMDTrace                if (anyKMDTrace) KMDTrace1
#define KMDTracex               if (anyKMDTrace) KMDTracex1

#endif
