
/*  C O P Y R I G H T   N O T I C E :                                     */
/* Copyright 1986 Eric Jul.  May not be used for any 			  */
/* purpose without written permission from the author.			  */

#ifndef LMTYPES
#define LMTYPES

#ifndef mmMsgTypes
#include "Kernel/h/mmMsgTypes.h"
#endif

typedef unsigned char       DataByte, *DataBytePtr;

typedef struct LMMsgHeader {
    DataBytePtr             ptr;        /* next free byte in msg */
    DataBytePtr             limit;      /* first byte past end */
    struct {
	int                 last:8;
        int                 id:24;
    } flags;
    struct LMMsg           *next;       /* link to next msg */
    MessageType             realMsgType;
    MessageSubtype          realMsgSubtype;
} LMMsgHeader, *LMMsgHeaderPtr;

#define MAXLMMESSAGESIZE (MAXMESSAGESIZE-sizeof(LMMsgHeader))

typedef struct LMMsg {
    MessageHeader           mmMsgHdr;
    LMMsgHeader             lmMsgHdr;
    DataByte                data[MAXLMMESSAGESIZE];
} LMMsg, *LMMsgPtr;

#define LMPutData(fHandle, fDataPtr, fDataLength)                       \
    if ((*(fHandle))->lmMsgHdr.ptr +(fDataLength) <= (*(fHandle))->lmMsgHdr.limit){\
	bcopy((char *)(fDataPtr), (char *)(*(fHandle))->lmMsgHdr.ptr, (int)(fDataLength));      \
	(*(fHandle))->lmMsgHdr.ptr += fDataLength;                        \
    } else LMPutLongData(fHandle, (DataBytePtr) fDataPtr, (unsigned int)  \
    fDataLength)

#define LMGetData(fHandle, fDataPtr, fDataLength)                           \
    if ((*(fHandle))->lmMsgHdr.ptr+(*(fDataLength)) <= (*(fHandle))->lmMsgHdr.limit) {\
	bcopy((char *)(*(fHandle))->lmMsgHdr.ptr, (char *)(fDataPtr),         \
        (int)*(fDataLength));                                                    \
	(*(fHandle))->lmMsgHdr.ptr += *(fDataLength);                       \
    } else LMGetLongData(fHandle, (DataBytePtr) fDataPtr,                   \
	(unsigned int *) fDataLength)

#define LMPacketPosition(fHandlePtr)					    \
    ( (*(fHandlePtr))->lmMsgHdr.flags.id )

typedef LMMsgPtr LMHandle;
typedef LMMsgPtr *LMHandlePtr;

extern KKStatus LMStartMsg(), LMPutLongData(),
    LMSendMsg(), LMBroadcastMsg(), LMSeek();
extern long LMCurrentPosition();
extern void LMInit(), LMGetLongData(), LMClose();

#endif LMTYPES
