/* File: Eden/Source/MsgOps/BufferTypes.h */

/*
 * $Header:   /u1/Eden/Source/MsgOps/RCS/BufferTypes.v  Revision 1.3  83/02/26  19:44:08  cady  Exp$
 * INTERFACE:	None.
 *
 * FUNCTION:	Provides the Message Module Buffer Services data types
 *              and interface.
 *
 * IMPORTS:     Eden/StdTypes.h.
 *
 * EXPORTS:	MAXDATASIZE, MMAllocateData, MMDeallocateData.
 *
 * DESIGN:      
 *
 * $Log:	/u1/Eden/Source/MsgOps/RCS/BufferTypes.v $
Revision 1.3  83/02/26  19:44:08  cady
Modified include files to be explicit.

Revision 1.2  83/01/04  15:13:05  cady
Revised include file specification.

Revision 1.1  83/01/03  10:59:59  cady
Initial revision

 * 4-Nov-1982	Initial implementation. S. Cady
 */

#ifndef mmBufTypes
#define mmBufTypes

#ifndef stdTypes
#include "Kernel/h/stdTypes.h"
#endif

#include "Kernel/h/mmMsgDefs.h"

/****************************************************************/
/*              Global Buffer Type Definitions                  */
/****************************************************************/

#define MAXDATASIZE 128

/*      Message Module Buffer Library External Definitions      */

extern KKStatus MMAllocateData();
extern void     MMDeallocateData();

#endif

/****************************************************************/
/*    End of Global Buffer Type Definitions                     */
/****************************************************************/
