/* File: /u1/Eden/Source/MsgOps/EtherTypes.h */

/*
 * $Header:   /u1/Eden/Source/MsgOps/RCS/EtherTypes.v  Revision 3.0  84/07/03  08:29:03  schwartz  Exp$
 * INTERFACE:	None.
 *
 * FUNCTION:	Defines the Ethernet data types and primitives.
 *
 * IMPORTS:	/u1/Eden/StdTypes.h,
 *              /u1/Eden/Source/MsgOps/MsgDefs.h.
 *
 * EXPORTS:	ETHERNETSIZE, EtherNetAddress,
 *              mEtherNull, mEtherCopy, mEtherIsEqual, mEtherPrint.
 *
 * DESIGN:      Ethernet addresses are Unix 4.2 sockaddr_in structures.
 *              (see socket(2) ).
 *
 * $Log:	/u1/Eden/Source/MsgOps/RCS/EtherTypes.v $
Revision 3.0  84/07/03  08:29:03  schwartz
Changed definitions to accomodate usage of Unix 4.2 sockets for network
interprocess communication

Revision 1.4  83/05/16  16:45:56  cady
Localized NullEtherNet definition.

Revision 1.3  83/02/26  19:44:43  cady
Modified include files to be explicit.

Revision 1.2  83/01/06  13:50:54  cady
Upgraded macros to procedures.

Revision 1.1  83/01/04  15:05:12  cady
Initial revision

 *  3-Jan-1982	Initial implementation. S. Cady
 */

#ifndef mmEthrTypes
#define mmEthrTypes

#ifndef upi_h
#ifndef makedev  /* this macro is defined in <sys/types.h> ; hence, this
                    ifndef keeps <sys/types.h> from being multiply included */
#include <sys/types.h>
#endif makedev

#include <sys/socket.h>
#include <netinet/in.h>
#endif

#ifndef stdTypes
#include "Kernel/h/stdTypes.h"
#endif

#include "Kernel/h/mmMsgDefs.h"

/****************************************************************/
/*              Global Ethernet Type Definitions                */
/****************************************************************/

#define ETHERNETSIZE    16

typedef struct sockaddr_in EtherNetAddress;

extern void    mEtherNull(),
               mEtherCopy(),
               mEtherPrint();
	       

extern Boolean mEtherIsEqual();
extern Boolean mEqualNetwork();
extern KKStatus mMakeEtherNetAddr();
extern KKStatus mMakeNextEtherNetAddr();
extern char * mGetHostName();

#endif

/****************************************************************/
/*          End of Global Ethernet Type Definitions             */
/****************************************************************/
