#ifndef system_h
#define system_h
#ifndef NULL
#include <stdio.h>
#endif

#include <sys/types.h>

extern int perror();

#define check(xxxx) { if (xxxx < 0) { perror("check"); abort();}}

#define Free(N) if ((int) (N) > 0x100) free((char *)(N));

extern int errno;
extern char *malloc(/* nBytes */);
/* unsigned int nBytes; */
extern char *calloc(/* nElements, nBytes */);
/* unsigned int nElement, nBytes; */

#ifdef RICEGC
/* If RICE collector is included then switch to it via the following macros */
#ifndef emalloc
/* (They may have been defined previously, if stdTypes.h has been included) */
#define emalloc(X) gc_malloc(X)
#define malloc(X)  gc_malloc(X)
#define free(X)    gc_free(X)
#define emfree(X)  gc_free(X)
#endif  emalloc
#endif RICEGC

extern void free();
extern void emfree();
extern char *emalloc(), *emallocnil();

extern char *sbrk();

extern char *strcat(), *strcpy(), *strncpy();
extern int bcopy();

extern int exit(/* status */);
/* int status; */

extern char *ctime();
extern time_t time();
extern long random();
extern int sigvec();
extern long seek(), lseek();
extern int sleep();
extern nlist();
extern int srandom();
extern char *inet_ntoa();
extern void ErrMsg(), QueueTask();
#endif
