/* File: /u1/Eden/Source/MsgOps/TimerTypes.h */

/*
 * $Header:   /u1/Eden/Source/MsgOps/RCS/TimerTypes.v  Revision 1.4  83/03/19  11:40:58  cady  Exp$
 * INTERFACE:	None.
 *
 * FUNCTION:	Provide the Message Module Timer Services Definitions.
 *
 * IMPORTS:	/u1/Eden/StdTypes.h,
 *              /u1/Eden/Source/MsgOps/MsgDefs.h.
 *
 * EXPORTS:	TimerId, MMSetTimer, MMCancelTimer, MMInitTimer,
 *              MMPrintTimerElt, MMPrintTimer, MMSetMicroTimer.
 *
 * DESIGN:      
 *
 * $Log:	/u1/Eden/Source/MsgOps/RCS/TimerTypes.v $
Revision 1.4  83/03/19  11:40:58  cady
Added NULLTIMERID constant definition.

Revision 1.3  83/03/01  17:05:49  cady
Added MMPrintTimer routines.
Revised to allow cancel after timeout, but before handler executed.

Revision 1.2  83/02/26  19:45:57  cady
Modified include files to be explicit.

Revision 1.1  83/01/06  14:13:00  cady
Initial revision

 * 4-Nov-1982	Initial implementation. S. Banawan
 */

#ifndef timerTypes
#define timerTypes

#ifndef stdTypes
#include "Kernel/h/stdTypes.h"
#endif

#ifndef mmMsgDefs
#include "Kernel/h/mmMsgDefs.h"
#endif

/****************************************************************/
/*                  Global Timer Type Definitions               */
/****************************************************************/

#define NULLTIMERID 0

typedef UnsignedInteger  TimerId;

extern KKStatus MMSetTimer(),
                MMSetMicroTimer(),
                MMCancelTimer();

extern void MMInitTimer();

extern void MMPrintTimerElt(),
            MMPrintTimer();

#endif

/****************************************************************/
/*          End of Global Timer Type Definitions                 */
/****************************************************************/
